/***************************************************************************
                          gamearea.cpp  -  description
                             -------------------
    begin                : Wed Feb 13 2002
    copyright            : (C) 2002 by Christoph Maciejewski
    email                : chrmac@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qpainter.h>
//#include <qdatetime.h>
#include <qtimer.h>
#include <qpointarray.h>
#include <qspinbox.h>
#include "warshipswindow.h"  // Win32
//#include "thegame.h"
#include "shootMenue.h"
#include "gamearea.h"
#include "bisbckg.xpm"
#include "bisbckg2.xpm"
#include "boom.xpm"
#include "plash.xpm"
//#include "mask2.xpm"

GameArea::GameArea(QWidget *parent, const char *name, QString picPath ) : QWidget(parent, name)
{
	p = new QPainter(this);           	
	
	bckgndship = new QPixmap(bis_bckg_xpm);	
	bckgndship2 = new QPixmap(bis_bckg2_xpm);
	boom = new QPixmap(boom_xpm);	  	
	plash = new QPixmap(plash_xpm);	
			
	bckgnd = new QPixmap(picPath+"night.png");   // nur provisorisch!   Win32: png
	bckgndsea = new QPixmap(picPath+"sea.bmp");   // nur provisorisch!	       bmp
	moon = new QPixmap(picPath+"moon.bmp");   // nur provisorisch!             bmp
	wind = new QPixmap(picPath+"wind.png");   // nur provisorisch!    	  	   png
	windLeft = new QPixmap(picPath+"wind-left.png");   // nur provisorisch!    png	
	windRight = new QPixmap(picPath+"wind-right.png");   // nur provisorisch!  png  	
	
	setBackgroundMode(PaletteBase);
	setBackgroundColor(QColor(0,0,0));
 	setBackgroundPixmap(*bckgnd);
 	 	
 	sea = new QLabel(this);
 	sea->setBackgroundPixmap(*bckgndsea);  	
 	
 	boomL = new QLabel(this);
 	boomL->setBackgroundPixmap(*boom);
 	boomL->hide(); 	
 	
 	plashL = new QLabel(this);
 	plashL->setBackgroundPixmap(*plash);
 	plashL->hide();
 	
 	QPointArray maske1 (5);
 	maske1.setPoints( 15, 0,30, 0,22, 20,20, 28,19, 36,14, 40,3, 45,3,
 											 46,14, 58,6, 67,18, 75,18, 83,22, 96,22, 100,18, 100,30 );  // Maske frs Schiff 				
 	
 	QPointArray maske2 (5);
 	maske2.setPoints( 15, 0,30, 0,18, 4,22, 17,22, 25,18, 33,18, 42,6,
 											 54,14, 55,3, 60,3, 64,14, 72,19, 80,20, 100,22, 100,30 );  // Maske frs Schiff  										
								

	ship = new QLabel(this);  	
 	ship->setBackgroundPixmap(*bckgndship);
 	 											
 	ship2 = new QLabel(this); 	
 	ship2->setBackgroundPixmap(*bckgndship2);

 	QRegion r1(maske1);
 	ship->setMask(r1);
 	
  QRegion r2(maske2);
 	ship2->setMask(r2);
   	 	
 	moonL = new QLabel(this);  	
 	moonL->setBackgroundPixmap(*moon);
 	
 	windL = new QLabel("10", this);
 	windL->setAlignment( AlignCenter | AlignVCenter ); 	
 	windL->setBackgroundPixmap(*wind); 	
}

GameArea::~GameArea()
{

}

//-----------------------------------------------

void GameArea::paintEvent( QPaintEvent * )
{
 	
}

//------------- Resize Event ---------------------------
void GameArea::resizeEvent (QResizeEvent *)
{
	sea->setGeometry(QRect(0, this->height()-100, this->width(), 100));	
	ship->setGeometry(QRect(50, this->height()-130, 100, 30));
	ship2->setGeometry(QRect(this->width()-150, this->height()-130, 100, 30));
	moonL->setGeometry(QRect(this->width()-150, 20, 30, 31));
	windL->setGeometry(QRect(this->width()/2-50, 10, 100, 35));
}

//-------------- Zeichnet das Projektil -----------------
void GameArea::drawShot(int x, int y, int end, int color)
{ 	
	if(end == 1)
  {    	
   	//p->drawPixmap ( x, y-15, *boom);
   	boomL->setGeometry(QRect(x-12, y-25, 25, 34));
   	boomL->show();
   	boomL->raise();
  }

  if(end == 2)
  {   	
   	plashL->setGeometry(QRect(x-12, y-18, 21, 29));
   	plashL->show();
   	plashL->raise();
 	}
 	
 	if(end == 0)
 	{
 		switch(color){
 			case 1: p->setBrush( green ); break;
 			case 2: p->setBrush( yellow ); break;
 			case 3: p->setBrush( red ); break; 			 			
 			}			
	 	
    p->drawEllipse(x, y, 5, 5);
  } 	
}

//-------------- Windrichtung anzeigen ------------------
void GameArea::setWindDirection(int windD)
{ 	
	if(windD == 0) windL->setBackgroundPixmap(*wind); 	
	if(windD > 0) windL->setBackgroundPixmap(*windRight); 	
	if(windD < 0) windL->setBackgroundPixmap(*windLeft); 	
}



