/***************************************************************************
                          gamearea.h  -  description
                             -------------------
    begin                : Wed Feb 13 2002
    copyright            : (C) 2002 by Christoph Maciejewski
    email                : chrmac@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEAREA_H
#define GAMEAREA_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qevent.h>
#include <qpainter.h>

/**
  *@author Christoph Maciejewski
  */

class GameArea : public QWidget  {
   Q_OBJECT
public: 
	GameArea(QWidget *parent=0, const char *name=0, QString picPath="/opt/Warships/");
	~GameArea();  	
	
	void drawShot(
		int x,  			// Position x
		int y,				// Position y
		int end,      // [0|1|2] Flugkurve|Explosion|Platsch
		int color=3		// Farbe des Projektils
		);
		
	void setWindDirection(int windD);
	              	
	QLabel *sea;
	QLabel *ship;
	QLabel *ship2;
	QLabel *moonL;
	QLabel *windL;
	QLabel *boomL;
	QLabel *plashL;
		
private slots:
			
	
protected:
	void resizeEvent(QResizeEvent *);
	void paintEvent(QPaintEvent *);     	
	
private:        	
	QPainter *p;
	
	QPixmap *bckgnd;
	QPixmap *bckgndsea;
	QPixmap *bckgndship;
	QPixmap *bckgndship2;
	QPixmap *tmp;
	QPixmap *shotp;
	QPixmap *moon;
	QPixmap *wind;
	QPixmap *windLeft;
	QPixmap *windRight;
	QPixmap *boom;
	QPixmap *plash;
		
 	QString backGndFile;
 	  	
};

#endif
